# com.storeharmony.api

Store Harmony v3 Merchant API
- API version: 1.0.0
  - Build date: 2020-06-10T20:28:38.627Z[GMT]

Store Harmony software is an inventory and sales management solution for all SMEs. It provides important functions enable integration of a merchant store with payment systems and banking applications. This API can be used by payment providers to enable easy integrated checkout for their products. Orders are sent directly to Store  point of sale and inventory software for immediate processing # Authentication StoreHarmony Merchant Checkout offers two forms of authentication:   - Bearer Authentication (Register on www.storeharmony as a merchant and API key can be requested)   - OAuth2 (to be available)   - HASH Optionally generate a HMAC-SHA256 hash of the request body and include as a Header X-Hash-Data This may be required for certain types of requests   


*Automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen)*


## Requirements

Building the API client library requires:
1. Java 1.7+
2. Maven/Gradle

## Installation

To install the API client library to your local Maven repository, simply execute:

```shell
mvn clean install
```

To deploy it to a remote Maven repository instead, configure the settings of the repository and execute:

```shell
mvn clean deploy
```

Refer to the [OSSRH Guide](http://central.sonatype.org/pages/ossrh-guide.html) for more information.

### Maven users

Add this dependency to your project's POM:

```xml
<dependency>
  <groupId>com.storeharmony.api</groupId>
  <artifactId>com.storeharmony.api</artifactId>
  <version>1.0.0</version>
  <scope>compile</scope>
</dependency>
```

### Gradle users

Add this dependency to your project's build file:

```groovy
compile "com.storeharmony.api:com.storeharmony.api:1.0.0"
```

### Others

At first generate the JAR by executing:

```shell
mvn clean package
```

Then manually install the following JARs:

* `target/com.storeharmony.api-1.0.0.jar`
* `target/lib/*.jar`

## Getting Started

Please follow the [installation](#installation) instruction and execute the following Java code:

```java
import com.storeharmony.api.invoke.*;
import com.storeharmony.api.invoke.auth.*;
import com.storeharmony.api.*;
import com.storeharmony.api.StoreHarmonyAccessApi;

import java.io.File;
import java.util.*;

public class StoreHarmonyAccessApiExample {

    public static void main(String[] args) {
        ApiClient defaultClient = Configuration.getDefaultApiClient();


        StoreHarmonyAccessApi apiInstance = new StoreHarmonyAccessApi();
        Registration body = new Registration(); // Registration | Registration details of user
        try {
            WebStore result = apiInstance.createMerchantStore(body);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling StoreHarmonyAccessApi#createMerchantStore");
            e.printStackTrace();
        }
    }
}
import com.storeharmony.api.invoke.*;
import com.storeharmony.api.invoke.auth.*;
import com.storeharmony.api.*;
import com.storeharmony.api.StoreHarmonyAccessApi;

import java.io.File;
import java.util.*;

public class StoreHarmonyAccessApiExample {

    public static void main(String[] args) {
        ApiClient defaultClient = Configuration.getDefaultApiClient();


        StoreHarmonyAccessApi apiInstance = new StoreHarmonyAccessApi();
        String storeid = "storeid_example"; // String | The store id of the specific store
        try {
            WebStore result = apiInstance.disableMerchantStore(storeid);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling StoreHarmonyAccessApi#disableMerchantStore");
            e.printStackTrace();
        }
    }
}
import com.storeharmony.api.invoke.*;
import com.storeharmony.api.invoke.auth.*;
import com.storeharmony.api.*;
import com.storeharmony.api.StoreHarmonyAccessApi;

import java.io.File;
import java.util.*;

public class StoreHarmonyAccessApiExample {

    public static void main(String[] args) {
        ApiClient defaultClient = Configuration.getDefaultApiClient();


        StoreHarmonyAccessApi apiInstance = new StoreHarmonyAccessApi();
        String storeid = "storeid_example"; // String | The id of the merchant store to be retrieved
        try {
            WebStore result = apiInstance.loadStoreInfo(storeid);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling StoreHarmonyAccessApi#loadStoreInfo");
            e.printStackTrace();
        }
    }
}
import com.storeharmony.api.invoke.*;
import com.storeharmony.api.invoke.auth.*;
import com.storeharmony.api.*;
import com.storeharmony.api.StoreHarmonyAccessApi;

import java.io.File;
import java.util.*;

public class StoreHarmonyAccessApiExample {

    public static void main(String[] args) {
        ApiClient defaultClient = Configuration.getDefaultApiClient();


        StoreHarmonyAccessApi apiInstance = new StoreHarmonyAccessApi();
        Credentials body = new Credentials(); // Credentials | login details of user
        try {
            WebStore result = apiInstance.loginToMerchantStore(body);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling StoreHarmonyAccessApi#loginToMerchantStore");
            e.printStackTrace();
        }
    }
}
import com.storeharmony.api.invoke.*;
import com.storeharmony.api.invoke.auth.*;
import com.storeharmony.api.*;
import com.storeharmony.api.StoreHarmonyAccessApi;

import java.io.File;
import java.util.*;

public class StoreHarmonyAccessApiExample {

    public static void main(String[] args) {
        ApiClient defaultClient = Configuration.getDefaultApiClient();


        StoreHarmonyAccessApi apiInstance = new StoreHarmonyAccessApi();
        Registration body = new Registration(); // Registration | Registration details of user
        String storeid = "storeid_example"; // String | The store id of the specific store
        try {
            WebStore result = apiInstance.updateMerchantStore(body, storeid);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling StoreHarmonyAccessApi#updateMerchantStore");
            e.printStackTrace();
        }
    }
}
```

## Documentation for API Endpoints

All URIs are relative to *https://storeharmony.net/webapi*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*StoreHarmonyAccessApi* | [**createMerchantStore**](docs/StoreHarmonyAccessApi.md#createMerchantStore) | **POST** /access/register | register a store on storeharmony
*StoreHarmonyAccessApi* | [**disableMerchantStore**](docs/StoreHarmonyAccessApi.md#disableMerchantStore) | **DELETE** /access/register/{storeid} | requests a deactivation of the account of a store
*StoreHarmonyAccessApi* | [**loadStoreInfo**](docs/StoreHarmonyAccessApi.md#loadStoreInfo) | **GET** /{storeid} | Retrieves a merchant store info from Storeharmony
*StoreHarmonyAccessApi* | [**loginToMerchantStore**](docs/StoreHarmonyAccessApi.md#loginToMerchantStore) | **POST** /access | creates a login request to retrieve the authorization token to make calls on behalf of the store
*StoreHarmonyAccessApi* | [**updateMerchantStore**](docs/StoreHarmonyAccessApi.md#updateMerchantStore) | **PUT** /access/register/{storeid} | updates a merchant info
*StoreHarmonyContactsApi* | [**createCustomer**](docs/StoreHarmonyContactsApi.md#createCustomer) | **POST** /contact/{storeid} | Create customer contacts for a store merchant
*StoreHarmonyContactsApi* | [**customerReport**](docs/StoreHarmonyContactsApi.md#customerReport) | **GET** /contact/report/{storeid} | Reports on the customer records giving best customer etc
*StoreHarmonyContactsApi* | [**deleteCustomer**](docs/StoreHarmonyContactsApi.md#deleteCustomer) | **DELETE** /contact/{storeid}/{customerid} | Deletes a customer contacts details for a store merchant
*StoreHarmonyContactsApi* | [**getCustomer**](docs/StoreHarmonyContactsApi.md#getCustomer) | **GET** /contact/{storeid}/{customerid} | Retrieves a customer contacts details for a store merchant
*StoreHarmonyContactsApi* | [**listCustomer**](docs/StoreHarmonyContactsApi.md#listCustomer) | **GET** /contact/{storeid} | List customer contacts for a store merchant
*StoreHarmonyContactsApi* | [**listCustomerByPage**](docs/StoreHarmonyContactsApi.md#listCustomerByPage) | **GET** /contact/{storeid}/{page}/{size} | List customer contacts for a store merchant
*StoreHarmonyContactsApi* | [**searchCustomer**](docs/StoreHarmonyContactsApi.md#searchCustomer) | **GET** /contact/{storeid}/{search}/{page}/{size} | List customer contacts for a store merchant
*StoreHarmonyContactsApi* | [**updateCustomer**](docs/StoreHarmonyContactsApi.md#updateCustomer) | **PUT** /contact/{storeid}/{customerid} | Updates a customer contacts details for a store merchant
*StoreHarmonyInventoryApi* | [**listStoreInventory**](docs/StoreHarmonyInventoryApi.md#listStoreInventory) | **GET** /{storeid}/inventory | retrieve list of products from the merchant store
*StoreHarmonyInventoryApi* | [**listStoreInventoryPaged**](docs/StoreHarmonyInventoryApi.md#listStoreInventoryPaged) | **GET** /{storeid}/{start}/{size} | retrieve list of products from the merchant store
*StoreHarmonyInventoryApi* | [**loadStoreCategories**](docs/StoreHarmonyInventoryApi.md#loadStoreCategories) | **GET** /{storeid}/categories | retrieve list of products categories from the merchant store
*StoreHarmonyInventoryApi* | [**loadStoreItem**](docs/StoreHarmonyInventoryApi.md#loadStoreItem) | **GET** /{storeid}/{itemid} | retrieve a product from the store getting its price, details and availability
*StoreHarmonyInventoryApi* | [**loadStoreItemBySlug**](docs/StoreHarmonyInventoryApi.md#loadStoreItemBySlug) | **GET** /{storeid}/slug/{slug} | retrieve a product from the store getting its price, details and availability via a slug
*StoreHarmonyInventoryApi* | [**loadStoreItemByUniqueId**](docs/StoreHarmonyInventoryApi.md#loadStoreItemByUniqueId) | **GET** /{storeid}/id/{itemid} | retrieve a product from the store getting its price, details and availability
*StoreHarmonyInventoryApi* | [**loadStoreItemsForCategory**](docs/StoreHarmonyInventoryApi.md#loadStoreItemsForCategory) | **GET** /{storeid}/category/{categoryid} | searches and retrieves a list of products from the merchant store for category
*StoreHarmonyInventoryApi* | [**loadStoreItemsForCategoryByPages**](docs/StoreHarmonyInventoryApi.md#loadStoreItemsForCategoryByPages) | **GET** /{storeid}/category/{categoryid}/{start}/{size} | searches and retrieves a list of products from the merchant store
*StoreHarmonyInventoryApi* | [**searchStoreRecords**](docs/StoreHarmonyInventoryApi.md#searchStoreRecords) | **GET** /{storeid}/{query}/{start}/{size} | searches and retrieves a list of products from the merchant store
*StoreHarmonyInventoryApi* | [**searchStoreRecordsMore**](docs/StoreHarmonyInventoryApi.md#searchStoreRecordsMore) | **POST** /{storeid}/search | retrieve list of products from the merchant store
*StoreHarmonyOrderingApi* | [**loadDeliveryServices**](docs/StoreHarmonyOrderingApi.md#loadDeliveryServices) | **GET** /{storeid}/delivery_services | retrieves the list of delivery services according to the zones supported by the store
*StoreHarmonyOrderingApi* | [**payForOrderViaCustomGateway**](docs/StoreHarmonyOrderingApi.md#payForOrderViaCustomGateway) | **POST** /{storeid}/order/pay | After an order has been placed and created with Storeharmony, the client can retrieve the order ID and use it to generate payment reference on their custom gateway implementation. They can use this call to pass the reference back to the storeharmony to use to verify the payment has been made. Popular gateways supported includes &#x27;pastack&#x27;, &#x27;flutterwave&#x27;, &#x27;global accelerex&#x27;, &#x27;sterling&#x27;
*StoreHarmonyOrderingApi* | [**payForOrderViaInternalGateway**](docs/StoreHarmonyOrderingApi.md#payForOrderViaInternalGateway) | **GET** /{storeid}/order/pay/{orderid} | After an order is made, you place this call to request storeharmony to give you a payment link to redirect customer to for payment. Gateway settngs are made via customer settings
*StoreHarmonyOrderingApi* | [**payViaMerchantPOSTerminal**](docs/StoreHarmonyOrderingApi.md#payViaMerchantPOSTerminal) | **POST** /terminal/order/pay/{terminalId} | For orders paid using a physical terminal or payment device, this call lets a PTSP notify storeharmony of a successful payment so that it can log it to the merchant dashboard or help fulfil a ecommerce order
*StoreHarmonyOrderingApi* | [**placeOrderToStore**](docs/StoreHarmonyOrderingApi.md#placeOrderToStore) | **POST** /{storeid}/order | places order of listed products to the merchant store. Note that a payment redirect link is also returned which allows the current buyer to make payment into this store if required. An implementation will redirect the customer to this link and later use /storeid/orderid to track the status of payment on this particular order
*StoreHarmonyOrderingApi* | [**verifyOrderPlaced**](docs/StoreHarmonyOrderingApi.md#verifyOrderPlaced) | **GET** /{storeid}/order/{orderid} | retrieve an Order from the store to check the status

## Documentation for Models

 - [AdvancedQuery](docs/AdvancedQuery.md)
 - [Category](docs/Category.md)
 - [Credentials](docs/Credentials.md)
 - [Customer](docs/Customer.md)
 - [CustomerData](docs/CustomerData.md)
 - [Registration](docs/Registration.md)
 - [TerminalPayment](docs/TerminalPayment.md)
 - [WebOrder](docs/WebOrder.md)
 - [WebOrderItem](docs/WebOrderItem.md)
 - [WebOrderPayment](docs/WebOrderPayment.md)
 - [WebProduct](docs/WebProduct.md)
 - [WebStore](docs/WebStore.md)
 - [WebStoreDetails](docs/WebStoreDetails.md)
 - [WebStoreItem](docs/WebStoreItem.md)
 - [WebSubProduct](docs/WebSubProduct.md)

## Documentation for Authorization

Authentication schemes defined for the API:
### bearerAuth



## Recommendation

It's recommended to create an instance of `ApiClient` per thread in a multithreaded environment to avoid any potential issues.

## Author


