/*
 * Store Harmony v3 Merchant API
 * Store Harmony software is an inventory and sales management solution for all SMEs. It provides important functions enable integration of a merchant store with payment systems and banking applications. This API can be used by payment providers to enable easy integrated checkout for their products. Orders are sent directly to Store  point of sale and inventory software for immediate processing # Authentication StoreHarmony Merchant Checkout offers two forms of authentication:   - Bearer Authentication (Register on www.storeharmony as a merchant and API key can be requested)   - OAuth2 (to be available)   - HASH Optionally generate a HMAC-SHA256 hash of the request body and include as a Header X-Hash-Data This may be required for certain types of requests   
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package com.storeharmony.api;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.storeharmony.api.Customer;
import io.swagger.v3.oas.annotations.media.Schema;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
/**
 * CustomerData
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2020-06-10T20:28:38.627Z[GMT]")
public class CustomerData {
  @JsonProperty("customerList")
  private List<Customer> customerList = null;

  @JsonProperty("success")
  private Boolean success = null;

  @JsonProperty("totalContacts")
  private Integer totalContacts = null;

  @JsonProperty("page")
  private Integer page = null;

  @JsonProperty("pageSize")
  private Integer pageSize = null;

  @JsonProperty("bestCustomer")
  private Customer bestCustomer = null;

  @JsonProperty("totalCustomers")
  private BigDecimal totalCustomers = null;

  @JsonProperty("totalActiveCustomers")
  private BigDecimal totalActiveCustomers = null;

  @JsonProperty("totalNewCustomers")
  private BigDecimal totalNewCustomers = null;

  public CustomerData customerList(List<Customer> customerList) {
    this.customerList = customerList;
    return this;
  }

  public CustomerData addCustomerListItem(Customer customerListItem) {
    if (this.customerList == null) {
      this.customerList = new ArrayList<Customer>();
    }
    this.customerList.add(customerListItem);
    return this;
  }

   /**
   * Get customerList
   * @return customerList
  **/
  @Schema(description = "")
  public List<Customer> getCustomerList() {
    return customerList;
  }

  public void setCustomerList(List<Customer> customerList) {
    this.customerList = customerList;
  }

  public CustomerData success(Boolean success) {
    this.success = success;
    return this;
  }

   /**
   * holds value for success
   * @return success
  **/
  @Schema(description = "holds value for success")
  public Boolean isSuccess() {
    return success;
  }

  public void setSuccess(Boolean success) {
    this.success = success;
  }

  public CustomerData totalContacts(Integer totalContacts) {
    this.totalContacts = totalContacts;
    return this;
  }

   /**
   * holds value for totalContacts
   * @return totalContacts
  **/
  @Schema(description = "holds value for totalContacts")
  public Integer getTotalContacts() {
    return totalContacts;
  }

  public void setTotalContacts(Integer totalContacts) {
    this.totalContacts = totalContacts;
  }

  public CustomerData page(Integer page) {
    this.page = page;
    return this;
  }

   /**
   * holds value for page
   * @return page
  **/
  @Schema(description = "holds value for page")
  public Integer getPage() {
    return page;
  }

  public void setPage(Integer page) {
    this.page = page;
  }

  public CustomerData pageSize(Integer pageSize) {
    this.pageSize = pageSize;
    return this;
  }

   /**
   * holds value for pageSize
   * @return pageSize
  **/
  @Schema(description = "holds value for pageSize")
  public Integer getPageSize() {
    return pageSize;
  }

  public void setPageSize(Integer pageSize) {
    this.pageSize = pageSize;
  }

  public CustomerData bestCustomer(Customer bestCustomer) {
    this.bestCustomer = bestCustomer;
    return this;
  }

   /**
   * Get bestCustomer
   * @return bestCustomer
  **/
  @Schema(description = "")
  public Customer getBestCustomer() {
    return bestCustomer;
  }

  public void setBestCustomer(Customer bestCustomer) {
    this.bestCustomer = bestCustomer;
  }

  public CustomerData totalCustomers(BigDecimal totalCustomers) {
    this.totalCustomers = totalCustomers;
    return this;
  }

   /**
   * holds value for totalCustomers
   * @return totalCustomers
  **/
  @Schema(description = "holds value for totalCustomers")
  public BigDecimal getTotalCustomers() {
    return totalCustomers;
  }

  public void setTotalCustomers(BigDecimal totalCustomers) {
    this.totalCustomers = totalCustomers;
  }

  public CustomerData totalActiveCustomers(BigDecimal totalActiveCustomers) {
    this.totalActiveCustomers = totalActiveCustomers;
    return this;
  }

   /**
   * holds value for totalActiveCustomers
   * @return totalActiveCustomers
  **/
  @Schema(description = "holds value for totalActiveCustomers")
  public BigDecimal getTotalActiveCustomers() {
    return totalActiveCustomers;
  }

  public void setTotalActiveCustomers(BigDecimal totalActiveCustomers) {
    this.totalActiveCustomers = totalActiveCustomers;
  }

  public CustomerData totalNewCustomers(BigDecimal totalNewCustomers) {
    this.totalNewCustomers = totalNewCustomers;
    return this;
  }

   /**
   * holds value for totalNewCustomers
   * @return totalNewCustomers
  **/
  @Schema(description = "holds value for totalNewCustomers")
  public BigDecimal getTotalNewCustomers() {
    return totalNewCustomers;
  }

  public void setTotalNewCustomers(BigDecimal totalNewCustomers) {
    this.totalNewCustomers = totalNewCustomers;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CustomerData customerData = (CustomerData) o;
    return Objects.equals(this.customerList, customerData.customerList) &&
        Objects.equals(this.success, customerData.success) &&
        Objects.equals(this.totalContacts, customerData.totalContacts) &&
        Objects.equals(this.page, customerData.page) &&
        Objects.equals(this.pageSize, customerData.pageSize) &&
        Objects.equals(this.bestCustomer, customerData.bestCustomer) &&
        Objects.equals(this.totalCustomers, customerData.totalCustomers) &&
        Objects.equals(this.totalActiveCustomers, customerData.totalActiveCustomers) &&
        Objects.equals(this.totalNewCustomers, customerData.totalNewCustomers);
  }

  @Override
  public int hashCode() {
    return Objects.hash(customerList, success, totalContacts, page, pageSize, bestCustomer, totalCustomers, totalActiveCustomers, totalNewCustomers);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CustomerData {\n");
    
    sb.append("    customerList: ").append(toIndentedString(customerList)).append("\n");
    sb.append("    success: ").append(toIndentedString(success)).append("\n");
    sb.append("    totalContacts: ").append(toIndentedString(totalContacts)).append("\n");
    sb.append("    page: ").append(toIndentedString(page)).append("\n");
    sb.append("    pageSize: ").append(toIndentedString(pageSize)).append("\n");
    sb.append("    bestCustomer: ").append(toIndentedString(bestCustomer)).append("\n");
    sb.append("    totalCustomers: ").append(toIndentedString(totalCustomers)).append("\n");
    sb.append("    totalActiveCustomers: ").append(toIndentedString(totalActiveCustomers)).append("\n");
    sb.append("    totalNewCustomers: ").append(toIndentedString(totalNewCustomers)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
