/*
 * Store Harmony v3 Merchant API
 * Store Harmony software is an inventory and sales management solution for all SMEs. It provides important functions enable integration of a merchant store with payment systems and banking applications. This API can be used by payment providers to enable easy integrated checkout for their products. Orders are sent directly to Store  point of sale and inventory software for immediate processing # Authentication StoreHarmony Merchant Checkout offers two forms of authentication:   - Bearer Authentication (Register on www.storeharmony as a merchant and API key can be requested)   - OAuth2 (to be available)   - HASH Optionally generate a HMAC-SHA256 hash of the request body and include as a Header X-Hash-Data This may be required for certain types of requests   
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
package com.storeharmony.api;

import com.sun.jersey.api.client.GenericType;

import com.storeharmony.api.invoke.ApiException;
import com.storeharmony.api.invoke.ApiClient;
import com.storeharmony.api.invoke.Configuration;
import com.storeharmony.api.*;

import com.storeharmony.api.invoke.Pair;

import com.storeharmony.api.Credentials;
import com.storeharmony.api.Registration;
import com.storeharmony.api.WebStore;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2020-06-10T20:28:38.627Z[GMT]")public class StoreHarmonyAccessApi {
  private ApiClient apiClient;

  public StoreHarmonyAccessApi() {
    this(Configuration.getDefaultApiClient());
  }

  public StoreHarmonyAccessApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * register a store on storeharmony
   * With an upgraded referral code, a store can be created on storeharmony from any external entity
   * @param body Registration details of user (required)
   * @return WebStore
   * @throws ApiException if fails to make API call
   */
  public WebStore createMerchantStore(Registration body) throws ApiException {
    Object localVarPostBody = body;
    // verify the required parameter 'body' is set
    if (body == null) {
      throw new ApiException(400, "Missing the required parameter 'body' when calling createMerchantStore");
    }
    // create path and map variables
    String localVarPath = "/access/register";

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<WebStore> localVarReturnType = new GenericType<WebStore>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * requests a deactivation of the account of a store
   * Enables a user request a cancellation of their storeharmony account 
   * @param storeid The store id of the specific store (required)
   * @return WebStore
   * @throws ApiException if fails to make API call
   */
  public WebStore disableMerchantStore(String storeid) throws ApiException {
    Object localVarPostBody = null;
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling disableMerchantStore");
    }
    // create path and map variables
    String localVarPath = "/access/register/{storeid}"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<WebStore> localVarReturnType = new GenericType<WebStore>() {};
    return apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * Retrieves a merchant store info from Storeharmony
   * To access details about the merchant being integrated with, call this method passing the merchant store id as generated by storeharmony and provided per merchant store
   * @param storeid The id of the merchant store to be retrieved (required)
   * @return WebStore
   * @throws ApiException if fails to make API call
   */
  public WebStore loadStoreInfo(String storeid) throws ApiException {
    Object localVarPostBody = null;
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling loadStoreInfo");
    }
    // create path and map variables
    String localVarPath = "/{storeid}"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<WebStore> localVarReturnType = new GenericType<WebStore>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * creates a login request to retrieve the authorization token to make calls on behalf of the store
   * Enables a user create a login request to retrieve the authorization token to make calls on behalf of the store
   * @param body login details of user (required)
   * @return WebStore
   * @throws ApiException if fails to make API call
   */
  public WebStore loginToMerchantStore(Credentials body) throws ApiException {
    Object localVarPostBody = body;
    // verify the required parameter 'body' is set
    if (body == null) {
      throw new ApiException(400, "Missing the required parameter 'body' when calling loginToMerchantStore");
    }
    // create path and map variables
    String localVarPath = "/access";

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<WebStore> localVarReturnType = new GenericType<WebStore>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * updates a merchant info
   * Enable update of a merchant info
   * @param body Registration details of user (required)
   * @param storeid The store id of the specific store (required)
   * @return WebStore
   * @throws ApiException if fails to make API call
   */
  public WebStore updateMerchantStore(Registration body, String storeid) throws ApiException {
    Object localVarPostBody = body;
    // verify the required parameter 'body' is set
    if (body == null) {
      throw new ApiException(400, "Missing the required parameter 'body' when calling updateMerchantStore");
    }
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling updateMerchantStore");
    }
    // create path and map variables
    String localVarPath = "/access/register/{storeid}"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<WebStore> localVarReturnType = new GenericType<WebStore>() {};
    return apiClient.invokeAPI(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
}
