/*
 * Store Harmony v3 Merchant API
 * Store Harmony software is an inventory and sales management solution for all SMEs. It provides important functions enable integration of a merchant store with payment systems and banking applications. This API can be used by payment providers to enable easy integrated checkout for their products. Orders are sent directly to Store  point of sale and inventory software for immediate processing # Authentication StoreHarmony Merchant Checkout offers two forms of authentication:   - Bearer Authentication (Register on www.storeharmony as a merchant and API key can be requested)   - OAuth2 (to be available)   - HASH Optionally generate a HMAC-SHA256 hash of the request body and include as a Header X-Hash-Data This may be required for certain types of requests   
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
package com.storeharmony.api;

import com.sun.jersey.api.client.GenericType;

import com.storeharmony.api.invoke.ApiException;
import com.storeharmony.api.invoke.ApiClient;
import com.storeharmony.api.invoke.Configuration;
import com.storeharmony.api.*;

import com.storeharmony.api.invoke.Pair;

import com.storeharmony.api.Customer;
import com.storeharmony.api.CustomerData;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2020-06-10T20:28:38.627Z[GMT]")public class StoreHarmonyContactsApi {
  private ApiClient apiClient;

  public StoreHarmonyContactsApi() {
    this(Configuration.getDefaultApiClient());
  }

  public StoreHarmonyContactsApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create customer contacts for a store merchant
   * Create a customer information for the merchant
   * @param body Customer contact details (required)
   * @param storeid The store id of the specific store (required)
   * @return CustomerData
   * @throws ApiException if fails to make API call
   */
  public CustomerData createCustomer(Customer body, String storeid) throws ApiException {
    Object localVarPostBody = body;
    // verify the required parameter 'body' is set
    if (body == null) {
      throw new ApiException(400, "Missing the required parameter 'body' when calling createCustomer");
    }
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling createCustomer");
    }
    // create path and map variables
    String localVarPath = "/contact/{storeid}"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<CustomerData> localVarReturnType = new GenericType<CustomerData>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * Reports on the customer records giving best customer etc
   * Returns a basic report on customer
   * @param storeid The store id of the specific store (required)
   * @return CustomerData
   * @throws ApiException if fails to make API call
   */
  public CustomerData customerReport(String storeid) throws ApiException {
    Object localVarPostBody = null;
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling customerReport");
    }
    // create path and map variables
    String localVarPath = "/contact/report/{storeid}"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<CustomerData> localVarReturnType = new GenericType<CustomerData>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * Deletes a customer contacts details for a store merchant
   * Deletes a customer of the merchant accouunt with provided ID
   * @param storeid The store id of the specific store (required)
   * @param customerid The customerid id of the contact (required)
   * @return Customer
   * @throws ApiException if fails to make API call
   */
  public Customer deleteCustomer(String storeid, String customerid) throws ApiException {
    Object localVarPostBody = null;
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling deleteCustomer");
    }
    // verify the required parameter 'customerid' is set
    if (customerid == null) {
      throw new ApiException(400, "Missing the required parameter 'customerid' when calling deleteCustomer");
    }
    // create path and map variables
    String localVarPath = "/contact/{storeid}/{customerid}"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()))
      .replaceAll("\\{" + "customerid" + "\\}", apiClient.escapeString(customerid.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<Customer> localVarReturnType = new GenericType<Customer>() {};
    return apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * Retrieves a customer contacts details for a store merchant
   * Retrieves a customer of the merchant accouunt with provided ID
   * @param storeid The store id of the specific store (required)
   * @param customerid The customerid id of the contact (required)
   * @return Customer
   * @throws ApiException if fails to make API call
   */
  public Customer getCustomer(String storeid, String customerid) throws ApiException {
    Object localVarPostBody = null;
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling getCustomer");
    }
    // verify the required parameter 'customerid' is set
    if (customerid == null) {
      throw new ApiException(400, "Missing the required parameter 'customerid' when calling getCustomer");
    }
    // create path and map variables
    String localVarPath = "/contact/{storeid}/{customerid}"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()))
      .replaceAll("\\{" + "customerid" + "\\}", apiClient.escapeString(customerid.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<Customer> localVarReturnType = new GenericType<Customer>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * List customer contacts for a store merchant
   * Returns the list of contacts for a merchant accouunt
   * @param storeid The store id of the specific store (required)
   * @return CustomerData
   * @throws ApiException if fails to make API call
   */
  public CustomerData listCustomer(String storeid) throws ApiException {
    Object localVarPostBody = null;
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling listCustomer");
    }
    // create path and map variables
    String localVarPath = "/contact/{storeid}"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<CustomerData> localVarReturnType = new GenericType<CustomerData>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * List customer contacts for a store merchant
   * Returns the list of contacts for a merchant accouunt
   * @param storeid The store id of the specific store (required)
   * @param page page number to start listing (required)
   * @param size size of records to list (required)
   * @return CustomerData
   * @throws ApiException if fails to make API call
   */
  public CustomerData listCustomerByPage(String storeid, String page, String size) throws ApiException {
    Object localVarPostBody = null;
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling listCustomerByPage");
    }
    // verify the required parameter 'page' is set
    if (page == null) {
      throw new ApiException(400, "Missing the required parameter 'page' when calling listCustomerByPage");
    }
    // verify the required parameter 'size' is set
    if (size == null) {
      throw new ApiException(400, "Missing the required parameter 'size' when calling listCustomerByPage");
    }
    // create path and map variables
    String localVarPath = "/contact/{storeid}/{page}/{size}"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()))
      .replaceAll("\\{" + "page" + "\\}", apiClient.escapeString(page.toString()))
      .replaceAll("\\{" + "size" + "\\}", apiClient.escapeString(size.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<CustomerData> localVarReturnType = new GenericType<CustomerData>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * List customer contacts for a store merchant
   * Returns the list of contacts for a merchant accouunt
   * @param storeid The store id of the specific store (required)
   * @param search The search query (required)
   * @param page page number to start listing (required)
   * @param size size of records to list (required)
   * @return CustomerData
   * @throws ApiException if fails to make API call
   */
  public CustomerData searchCustomer(String storeid, String search, String page, String size) throws ApiException {
    Object localVarPostBody = null;
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling searchCustomer");
    }
    // verify the required parameter 'search' is set
    if (search == null) {
      throw new ApiException(400, "Missing the required parameter 'search' when calling searchCustomer");
    }
    // verify the required parameter 'page' is set
    if (page == null) {
      throw new ApiException(400, "Missing the required parameter 'page' when calling searchCustomer");
    }
    // verify the required parameter 'size' is set
    if (size == null) {
      throw new ApiException(400, "Missing the required parameter 'size' when calling searchCustomer");
    }
    // create path and map variables
    String localVarPath = "/contact/{storeid}/{search}/{page}/{size}"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()))
      .replaceAll("\\{" + "search" + "\\}", apiClient.escapeString(search.toString()))
      .replaceAll("\\{" + "page" + "\\}", apiClient.escapeString(page.toString()))
      .replaceAll("\\{" + "size" + "\\}", apiClient.escapeString(size.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<CustomerData> localVarReturnType = new GenericType<CustomerData>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * Updates a customer contacts details for a store merchant
   * Updates a customer of the merchant accouunt with provided ID
   * @param body Customer contact details (required)
   * @param storeid The store id of the specific store (required)
   * @param customerid The customerid id of the contact (required)
   * @return Customer
   * @throws ApiException if fails to make API call
   */
  public Customer updateCustomer(Customer body, String storeid, String customerid) throws ApiException {
    Object localVarPostBody = body;
    // verify the required parameter 'body' is set
    if (body == null) {
      throw new ApiException(400, "Missing the required parameter 'body' when calling updateCustomer");
    }
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling updateCustomer");
    }
    // verify the required parameter 'customerid' is set
    if (customerid == null) {
      throw new ApiException(400, "Missing the required parameter 'customerid' when calling updateCustomer");
    }
    // create path and map variables
    String localVarPath = "/contact/{storeid}/{customerid}"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()))
      .replaceAll("\\{" + "customerid" + "\\}", apiClient.escapeString(customerid.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<Customer> localVarReturnType = new GenericType<Customer>() {};
    return apiClient.invokeAPI(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
}
