/*
 * Store Harmony v3 Merchant API
 * Store Harmony software is an inventory and sales management solution for all SMEs. It provides important functions enable integration of a merchant store with payment systems and banking applications. This API can be used by payment providers to enable easy integrated checkout for their products. Orders are sent directly to Store  point of sale and inventory software for immediate processing # Authentication StoreHarmony Merchant Checkout offers two forms of authentication:   - Bearer Authentication (Register on www.storeharmony as a merchant and API key can be requested)   - OAuth2 (to be available)   - HASH Optionally generate a HMAC-SHA256 hash of the request body and include as a Header X-Hash-Data This may be required for certain types of requests   
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
package com.storeharmony.api;

import com.sun.jersey.api.client.GenericType;

import com.storeharmony.api.invoke.ApiException;
import com.storeharmony.api.invoke.ApiClient;
import com.storeharmony.api.invoke.Configuration;
import com.storeharmony.api.*;

import com.storeharmony.api.invoke.Pair;

import com.storeharmony.api.AdvancedQuery;
import com.storeharmony.api.WebStore;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2020-06-10T20:28:38.627Z[GMT]")public class StoreHarmonyInventoryApi {
  private ApiClient apiClient;

  public StoreHarmonyInventoryApi() {
    this(Configuration.getDefaultApiClient());
  }

  public StoreHarmonyInventoryApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * retrieve list of products from the merchant store
   * Returns a list of available items from a merchant store which can be displayed for a client app to use to info their users on prices or availablity
   * @param storeid The store id of the specific store (required)
   * @return WebStore
   * @throws ApiException if fails to make API call
   */
  public WebStore listStoreInventory(String storeid) throws ApiException {
    Object localVarPostBody = null;
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling listStoreInventory");
    }
    // create path and map variables
    String localVarPath = "/{storeid}/inventory"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<WebStore> localVarReturnType = new GenericType<WebStore>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * retrieve list of products from the merchant store
   * Returns a list of available items from a merchant store which can be displayed for a client app to use to info their users on prices or availablity
   * @param storeid The store id of the specific store (required)
   * @param start The start of page of listed products (required)
   * @param size The size of page of listed products (required)
   * @return WebStore
   * @throws ApiException if fails to make API call
   */
  public WebStore listStoreInventoryPaged(String storeid, String start, String size) throws ApiException {
    Object localVarPostBody = null;
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling listStoreInventoryPaged");
    }
    // verify the required parameter 'start' is set
    if (start == null) {
      throw new ApiException(400, "Missing the required parameter 'start' when calling listStoreInventoryPaged");
    }
    // verify the required parameter 'size' is set
    if (size == null) {
      throw new ApiException(400, "Missing the required parameter 'size' when calling listStoreInventoryPaged");
    }
    // create path and map variables
    String localVarPath = "/{storeid}/{start}/{size}"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()))
      .replaceAll("\\{" + "start" + "\\}", apiClient.escapeString(start.toString()))
      .replaceAll("\\{" + "size" + "\\}", apiClient.escapeString(size.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<WebStore> localVarReturnType = new GenericType<WebStore>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * retrieve list of products categories from the merchant store
   * Returns a list of available items from a merchant store which can be displayed for a client app to use to info their users on prices or availablity
   * @param storeid The store id of the specific store (required)
   * @return WebStore
   * @throws ApiException if fails to make API call
   */
  public WebStore loadStoreCategories(String storeid) throws ApiException {
    Object localVarPostBody = null;
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling loadStoreCategories");
    }
    // create path and map variables
    String localVarPath = "/{storeid}/categories"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<WebStore> localVarReturnType = new GenericType<WebStore>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * retrieve a product from the store getting its price, details and availability
   * Returns the details about a store product which can be connected to a payment process or checkout process
   * @param storeid The store id of the specific store (required)
   * @param itemid The itemid carrying the ID or slug of the product being loaded (required)
   * @return WebStore
   * @throws ApiException if fails to make API call
   */
  public WebStore loadStoreItem(String storeid, String itemid) throws ApiException {
    Object localVarPostBody = null;
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling loadStoreItem");
    }
    // verify the required parameter 'itemid' is set
    if (itemid == null) {
      throw new ApiException(400, "Missing the required parameter 'itemid' when calling loadStoreItem");
    }
    // create path and map variables
    String localVarPath = "/{storeid}/{itemid}"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()))
      .replaceAll("\\{" + "itemid" + "\\}", apiClient.escapeString(itemid.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<WebStore> localVarReturnType = new GenericType<WebStore>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * retrieve a product from the store getting its price, details and availability via a slug
   * Returns the details about a store product usnig its slug
   * @param storeid The store id of the specific store (required)
   * @param slug The slug carrying the ID or slug of the product being loaded (required)
   * @return WebStore
   * @throws ApiException if fails to make API call
   */
  public WebStore loadStoreItemBySlug(String storeid, String slug) throws ApiException {
    Object localVarPostBody = null;
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling loadStoreItemBySlug");
    }
    // verify the required parameter 'slug' is set
    if (slug == null) {
      throw new ApiException(400, "Missing the required parameter 'slug' when calling loadStoreItemBySlug");
    }
    // create path and map variables
    String localVarPath = "/{storeid}/slug/{slug}"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()))
      .replaceAll("\\{" + "slug" + "\\}", apiClient.escapeString(slug.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<WebStore> localVarReturnType = new GenericType<WebStore>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * retrieve a product from the store getting its price, details and availability
   * Returns the details about a store product usnig its universal ID
   * @param storeid The store id of the specific store (required)
   * @param itemid The itemid carrying the ID or slug of the product being loaded (required)
   * @return WebStore
   * @throws ApiException if fails to make API call
   */
  public WebStore loadStoreItemByUniqueId(String storeid, String itemid) throws ApiException {
    Object localVarPostBody = null;
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling loadStoreItemByUniqueId");
    }
    // verify the required parameter 'itemid' is set
    if (itemid == null) {
      throw new ApiException(400, "Missing the required parameter 'itemid' when calling loadStoreItemByUniqueId");
    }
    // create path and map variables
    String localVarPath = "/{storeid}/id/{itemid}"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()))
      .replaceAll("\\{" + "itemid" + "\\}", apiClient.escapeString(itemid.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<WebStore> localVarReturnType = new GenericType<WebStore>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * searches and retrieves a list of products from the merchant store for category
   * Returns a query of available items from a merchant store which can be displayed for a client app to use to info their users on prices or availablity under a category
   * @param storeid The store id of the specific store (required)
   * @param categoryid The category id returned from categories call. See /storeid/categories (required)
   * @return WebStore
   * @throws ApiException if fails to make API call
   */
  public WebStore loadStoreItemsForCategory(String storeid, String categoryid) throws ApiException {
    Object localVarPostBody = null;
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling loadStoreItemsForCategory");
    }
    // verify the required parameter 'categoryid' is set
    if (categoryid == null) {
      throw new ApiException(400, "Missing the required parameter 'categoryid' when calling loadStoreItemsForCategory");
    }
    // create path and map variables
    String localVarPath = "/{storeid}/category/{categoryid}"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()))
      .replaceAll("\\{" + "categoryid" + "\\}", apiClient.escapeString(categoryid.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<WebStore> localVarReturnType = new GenericType<WebStore>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * searches and retrieves a list of products from the merchant store
   * Returns a query of available items from a merchant store which can be displayed for a client app to use to info their users on prices or availablity
   * @param storeid The store id of the specific store (required)
   * @param categoryid The categoryid of the category (required)
   * @param start The start of page of listed products (required)
   * @param size The size of page of listed products (required)
   * @return WebStore
   * @throws ApiException if fails to make API call
   */
  public WebStore loadStoreItemsForCategoryByPages(String storeid, String categoryid, String start, String size) throws ApiException {
    Object localVarPostBody = null;
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling loadStoreItemsForCategoryByPages");
    }
    // verify the required parameter 'categoryid' is set
    if (categoryid == null) {
      throw new ApiException(400, "Missing the required parameter 'categoryid' when calling loadStoreItemsForCategoryByPages");
    }
    // verify the required parameter 'start' is set
    if (start == null) {
      throw new ApiException(400, "Missing the required parameter 'start' when calling loadStoreItemsForCategoryByPages");
    }
    // verify the required parameter 'size' is set
    if (size == null) {
      throw new ApiException(400, "Missing the required parameter 'size' when calling loadStoreItemsForCategoryByPages");
    }
    // create path and map variables
    String localVarPath = "/{storeid}/category/{categoryid}/{start}/{size}"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()))
      .replaceAll("\\{" + "categoryid" + "\\}", apiClient.escapeString(categoryid.toString()))
      .replaceAll("\\{" + "start" + "\\}", apiClient.escapeString(start.toString()))
      .replaceAll("\\{" + "size" + "\\}", apiClient.escapeString(size.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<WebStore> localVarReturnType = new GenericType<WebStore>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * searches and retrieves a list of products from the merchant store
   * Returns a query of available items from a merchant store which can be displayed for a client app to use to info their users on prices or availablity
   * @param storeid The store id of the specific store (required)
   * @param query The query string (required)
   * @param start The start of page of listed products (required)
   * @param size The size of page of listed products (required)
   * @return WebStore
   * @throws ApiException if fails to make API call
   */
  public WebStore searchStoreRecords(String storeid, String query, String start, String size) throws ApiException {
    Object localVarPostBody = null;
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling searchStoreRecords");
    }
    // verify the required parameter 'query' is set
    if (query == null) {
      throw new ApiException(400, "Missing the required parameter 'query' when calling searchStoreRecords");
    }
    // verify the required parameter 'start' is set
    if (start == null) {
      throw new ApiException(400, "Missing the required parameter 'start' when calling searchStoreRecords");
    }
    // verify the required parameter 'size' is set
    if (size == null) {
      throw new ApiException(400, "Missing the required parameter 'size' when calling searchStoreRecords");
    }
    // create path and map variables
    String localVarPath = "/{storeid}/{query}/{start}/{size}"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()))
      .replaceAll("\\{" + "query" + "\\}", apiClient.escapeString(query.toString()))
      .replaceAll("\\{" + "start" + "\\}", apiClient.escapeString(start.toString()))
      .replaceAll("\\{" + "size" + "\\}", apiClient.escapeString(size.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<WebStore> localVarReturnType = new GenericType<WebStore>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * retrieve list of products from the merchant store
   * Returns a list of available items from a merchant store which can be displayed for a client app to use to info their users on prices or availablity
   * @param body unique identifier of inventory item (required)
   * @param storeid The store id of the specific store (required)
   * @return WebStore
   * @throws ApiException if fails to make API call
   */
  public WebStore searchStoreRecordsMore(AdvancedQuery body, String storeid) throws ApiException {
    Object localVarPostBody = body;
    // verify the required parameter 'body' is set
    if (body == null) {
      throw new ApiException(400, "Missing the required parameter 'body' when calling searchStoreRecordsMore");
    }
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling searchStoreRecordsMore");
    }
    // create path and map variables
    String localVarPath = "/{storeid}/search"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<WebStore> localVarReturnType = new GenericType<WebStore>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
}
