/*
 * Store Harmony v3 Merchant API
 * Store Harmony software is an inventory and sales management solution for all SMEs. It provides important functions enable integration of a merchant store with payment systems and banking applications. This API can be used by payment providers to enable easy integrated checkout for their products. Orders are sent directly to Store  point of sale and inventory software for immediate processing # Authentication StoreHarmony Merchant Checkout offers two forms of authentication:   - Bearer Authentication (Register on www.storeharmony as a merchant and API key can be requested)   - OAuth2 (to be available)   - HASH Optionally generate a HMAC-SHA256 hash of the request body and include as a Header X-Hash-Data This may be required for certain types of requests   
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
package com.storeharmony.api;

import com.sun.jersey.api.client.GenericType;

import com.storeharmony.api.invoke.ApiException;
import com.storeharmony.api.invoke.ApiClient;
import com.storeharmony.api.invoke.Configuration;
import com.storeharmony.api.*;

import com.storeharmony.api.invoke.Pair;

import com.storeharmony.api.TerminalPayment;
import com.storeharmony.api.WebOrder;
import com.storeharmony.api.WebOrderPayment;
import com.storeharmony.api.WebStore;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2020-06-10T20:28:38.627Z[GMT]")public class StoreHarmonyOrderingApi {
  private ApiClient apiClient;

  public StoreHarmonyOrderingApi() {
    this(Configuration.getDefaultApiClient());
  }

  public StoreHarmonyOrderingApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * retrieves the list of delivery services according to the zones supported by the store
   * A store owner can map out the price of making deliveries to each part of their coverage. A zone could be titled &#x27;lagos mainland delivery&#x27; or &#x27;central area delivery&#x27;. Prices are listed per KG
   * @param storeid The store id of the specific store (required)
   * @return WebStore
   * @throws ApiException if fails to make API call
   */
  public WebStore loadDeliveryServices(String storeid) throws ApiException {
    Object localVarPostBody = null;
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling loadDeliveryServices");
    }
    // create path and map variables
    String localVarPath = "/{storeid}/delivery_services"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<WebStore> localVarReturnType = new GenericType<WebStore>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * After an order has been placed and created with Storeharmony, the client can retrieve the order ID and use it to generate payment reference on their custom gateway implementation. They can use this call to pass the reference back to the storeharmony to use to verify the payment has been made. Popular gateways supported includes &#x27;pastack&#x27;, &#x27;flutterwave&#x27;, &#x27;global accelerex&#x27;, &#x27;sterling&#x27;
   * Send payment for an already placed order. This call is made to notify storeharmony that an order has been paid for using a custom payment gateway implementation
   * @param body Details of payment for an order (required)
   * @param storeid The store id of the specific store (required)
   * @return WebStore
   * @throws ApiException if fails to make API call
   */
  public WebStore payForOrderViaCustomGateway(WebOrderPayment body, String storeid) throws ApiException {
    Object localVarPostBody = body;
    // verify the required parameter 'body' is set
    if (body == null) {
      throw new ApiException(400, "Missing the required parameter 'body' when calling payForOrderViaCustomGateway");
    }
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling payForOrderViaCustomGateway");
    }
    // create path and map variables
    String localVarPath = "/{storeid}/order/pay"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<WebStore> localVarReturnType = new GenericType<WebStore>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * After an order is made, you place this call to request storeharmony to give you a payment link to redirect customer to for payment. Gateway settngs are made via customer settings
   * To allow merchants use the embedded wallet function on their storeharmony or stocker, this call is important for payment processing. After an order is made, you place this call to request storeharmony to give you a payment link to redirect customer to for payment
   * @param storeid The store id of the specific store (required)
   * @param orderid The orderid of the Order to be traced from the store whi (required)
   * @return WebStore
   * @throws ApiException if fails to make API call
   */
  public WebStore payForOrderViaInternalGateway(String storeid, String orderid) throws ApiException {
    Object localVarPostBody = null;
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling payForOrderViaInternalGateway");
    }
    // verify the required parameter 'orderid' is set
    if (orderid == null) {
      throw new ApiException(400, "Missing the required parameter 'orderid' when calling payForOrderViaInternalGateway");
    }
    // create path and map variables
    String localVarPath = "/{storeid}/order/pay/{orderid}"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()))
      .replaceAll("\\{" + "orderid" + "\\}", apiClient.escapeString(orderid.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<WebStore> localVarReturnType = new GenericType<WebStore>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * For orders paid using a physical terminal or payment device, this call lets a PTSP notify storeharmony of a successful payment so that it can log it to the merchant dashboard or help fulfil a ecommerce order
   * For orders paid using a physical terminal or payment device, the PTSP should create a callback that calls Storeharmony using this API to notify that a merchant on its network has been paid. A simple plugin can be developed to trigger this call
   * @param body Details of a terminal payment from a physical payment gateway (required)
   * @param terminalId The store id of the specific store (required)
   * @return WebStore
   * @throws ApiException if fails to make API call
   */
  public WebStore payViaMerchantPOSTerminal(TerminalPayment body, String terminalId) throws ApiException {
    Object localVarPostBody = body;
    // verify the required parameter 'body' is set
    if (body == null) {
      throw new ApiException(400, "Missing the required parameter 'body' when calling payViaMerchantPOSTerminal");
    }
    // verify the required parameter 'terminalId' is set
    if (terminalId == null) {
      throw new ApiException(400, "Missing the required parameter 'terminalId' when calling payViaMerchantPOSTerminal");
    }
    // create path and map variables
    String localVarPath = "/terminal/order/pay/{terminalId}"
      .replaceAll("\\{" + "terminalId" + "\\}", apiClient.escapeString(terminalId.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<WebStore> localVarReturnType = new GenericType<WebStore>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * places order of listed products to the merchant store. Note that a payment redirect link is also returned which allows the current buyer to make payment into this store if required. An implementation will redirect the customer to this link and later use /storeid/orderid to track the status of payment on this particular order
   * Creates an order which is placed to the store dashboard for the merchant to immediately attend from their point of sales
   * @param body unique identifier of inventory item (required)
   * @param storeid The store id of the specific store (required)
   * @return WebStore
   * @throws ApiException if fails to make API call
   */
  public WebStore placeOrderToStore(WebOrder body, String storeid) throws ApiException {
    Object localVarPostBody = body;
    // verify the required parameter 'body' is set
    if (body == null) {
      throw new ApiException(400, "Missing the required parameter 'body' when calling placeOrderToStore");
    }
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling placeOrderToStore");
    }
    // create path and map variables
    String localVarPath = "/{storeid}/order"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<WebStore> localVarReturnType = new GenericType<WebStore>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
  /**
   * retrieve an Order from the store to check the status
   * Returns the details about the provided Order ID which also indicates if there is any successful payments and payment references on it
   * @param storeid The store id of the specific store (required)
   * @param orderid The orderid of the Order to be traced from the store whi (required)
   * @return WebStore
   * @throws ApiException if fails to make API call
   */
  public WebStore verifyOrderPlaced(String storeid, String orderid) throws ApiException {
    Object localVarPostBody = null;
    // verify the required parameter 'storeid' is set
    if (storeid == null) {
      throw new ApiException(400, "Missing the required parameter 'storeid' when calling verifyOrderPlaced");
    }
    // verify the required parameter 'orderid' is set
    if (orderid == null) {
      throw new ApiException(400, "Missing the required parameter 'orderid' when calling verifyOrderPlaced");
    }
    // create path and map variables
    String localVarPath = "/{storeid}/order/{orderid}"
      .replaceAll("\\{" + "storeid" + "\\}", apiClient.escapeString(storeid.toString()))
      .replaceAll("\\{" + "orderid" + "\\}", apiClient.escapeString(orderid.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    
    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "bearerAuth" };

    GenericType<WebStore> localVarReturnType = new GenericType<WebStore>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
  }
}
