/*
 * Store Harmony v3 Merchant API
 * Store Harmony software is an inventory and sales management solution for all SMEs. It provides important functions enable integration of a merchant store with payment systems and banking applications. This API can be used by payment providers to enable easy integrated checkout for their products. Orders are sent directly to Store  point of sale and inventory software for immediate processing # Authentication StoreHarmony Merchant Checkout offers two forms of authentication:   - Bearer Authentication (Register on www.storeharmony as a merchant and API key can be requested)   - OAuth2 (to be available)   - HASH Optionally generate a HMAC-SHA256 hash of the request body and include as a Header X-Hash-Data This may be required for certain types of requests   
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package com.storeharmony.api;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.v3.oas.annotations.media.Schema;
/**
 * TerminalPayment
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2020-06-10T20:28:38.627Z[GMT]")
public class TerminalPayment {
  @JsonProperty("storeid")
  private String storeid = null;

  @JsonProperty("reference")
  private String reference = null;

  @JsonProperty("harmonyInvoiceId")
  private String harmonyInvoiceId = null;

  @JsonProperty("gateway")
  private String gateway = null;

  @JsonProperty("tDate")
  private String tDate = null;

  @JsonProperty("amount")
  private Integer amount = null;

  @JsonProperty("bank")
  private String bank = null;

  @JsonProperty("remarks")
  private String remarks = null;

  @JsonProperty("status")
  private String status = null;

  public TerminalPayment storeid(String storeid) {
    this.storeid = storeid;
    return this;
  }

   /**
   * the store id of the store to be paid for.
   * @return storeid
  **/
  @Schema(description = "the store id of the store to be paid for.")
  public String getStoreid() {
    return storeid;
  }

  public void setStoreid(String storeid) {
    this.storeid = storeid;
  }

  public TerminalPayment reference(String reference) {
    this.reference = reference;
    return this;
  }

   /**
   * transaction reference of the accepted payment
   * @return reference
  **/
  @Schema(description = "transaction reference of the accepted payment")
  public String getReference() {
    return reference;
  }

  public void setReference(String reference) {
    this.reference = reference;
  }

  public TerminalPayment harmonyInvoiceId(String harmonyInvoiceId) {
    this.harmonyInvoiceId = harmonyInvoiceId;
    return this;
  }

   /**
   * if available, pass the global unique invoice ID from storeharmony associated with this payment
   * @return harmonyInvoiceId
  **/
  @Schema(description = "if available, pass the global unique invoice ID from storeharmony associated with this payment")
  public String getHarmonyInvoiceId() {
    return harmonyInvoiceId;
  }

  public void setHarmonyInvoiceId(String harmonyInvoiceId) {
    this.harmonyInvoiceId = harmonyInvoiceId;
  }

  public TerminalPayment gateway(String gateway) {
    this.gateway = gateway;
    return this;
  }

   /**
   * name of provider
   * @return gateway
  **/
  @Schema(description = "name of provider")
  public String getGateway() {
    return gateway;
  }

  public void setGateway(String gateway) {
    this.gateway = gateway;
  }

  public TerminalPayment tDate(String tDate) {
    this.tDate = tDate;
    return this;
  }

   /**
   * date time of the transaction
   * @return tDate
  **/
  @Schema(description = "date time of the transaction")
  public String getTDate() {
    return tDate;
  }

  public void setTDate(String tDate) {
    this.tDate = tDate;
  }

  public TerminalPayment amount(Integer amount) {
    this.amount = amount;
    return this;
  }

   /**
   * amount of payment received
   * @return amount
  **/
  @Schema(description = "amount of payment received")
  public Integer getAmount() {
    return amount;
  }

  public void setAmount(Integer amount) {
    this.amount = amount;
  }

  public TerminalPayment bank(String bank) {
    this.bank = bank;
    return this;
  }

   /**
   * name of merchant bank
   * @return bank
  **/
  @Schema(description = "name of merchant bank")
  public String getBank() {
    return bank;
  }

  public void setBank(String bank) {
    this.bank = bank;
  }

  public TerminalPayment remarks(String remarks) {
    this.remarks = remarks;
    return this;
  }

   /**
   * transaction remarks of payment received
   * @return remarks
  **/
  @Schema(description = "transaction remarks of payment received")
  public String getRemarks() {
    return remarks;
  }

  public void setRemarks(String remarks) {
    this.remarks = remarks;
  }

  public TerminalPayment status(String status) {
    this.status = status;
    return this;
  }

   /**
   * status of transaction either fail or pass
   * @return status
  **/
  @Schema(description = "status of transaction either fail or pass")
  public String getStatus() {
    return status;
  }

  public void setStatus(String status) {
    this.status = status;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TerminalPayment terminalPayment = (TerminalPayment) o;
    return Objects.equals(this.storeid, terminalPayment.storeid) &&
        Objects.equals(this.reference, terminalPayment.reference) &&
        Objects.equals(this.harmonyInvoiceId, terminalPayment.harmonyInvoiceId) &&
        Objects.equals(this.gateway, terminalPayment.gateway) &&
        Objects.equals(this.tDate, terminalPayment.tDate) &&
        Objects.equals(this.amount, terminalPayment.amount) &&
        Objects.equals(this.bank, terminalPayment.bank) &&
        Objects.equals(this.remarks, terminalPayment.remarks) &&
        Objects.equals(this.status, terminalPayment.status);
  }

  @Override
  public int hashCode() {
    return Objects.hash(storeid, reference, harmonyInvoiceId, gateway, tDate, amount, bank, remarks, status);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TerminalPayment {\n");
    
    sb.append("    storeid: ").append(toIndentedString(storeid)).append("\n");
    sb.append("    reference: ").append(toIndentedString(reference)).append("\n");
    sb.append("    harmonyInvoiceId: ").append(toIndentedString(harmonyInvoiceId)).append("\n");
    sb.append("    gateway: ").append(toIndentedString(gateway)).append("\n");
    sb.append("    tDate: ").append(toIndentedString(tDate)).append("\n");
    sb.append("    amount: ").append(toIndentedString(amount)).append("\n");
    sb.append("    bank: ").append(toIndentedString(bank)).append("\n");
    sb.append("    remarks: ").append(toIndentedString(remarks)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
