/*
 * Store Harmony v3 Merchant API
 * Store Harmony software is an inventory and sales management solution for all SMEs. It provides important functions enable integration of a merchant store with payment systems and banking applications. This API can be used by payment providers to enable easy integrated checkout for their products. Orders are sent directly to Store  point of sale and inventory software for immediate processing # Authentication StoreHarmony Merchant Checkout offers two forms of authentication:   - Bearer Authentication (Register on www.storeharmony as a merchant and API key can be requested)   - OAuth2 (to be available)   - HASH Optionally generate a HMAC-SHA256 hash of the request body and include as a Header X-Hash-Data This may be required for certain types of requests   
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package com.storeharmony.api;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.storeharmony.api.WebSubProduct;
import io.swagger.v3.oas.annotations.media.Schema;
import java.util.ArrayList;
import java.util.List;
/**
 * WebProduct
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2020-06-10T20:28:38.627Z[GMT]")
public class WebProduct {
  @JsonProperty("id")
  private String id = null;

  @JsonProperty("name")
  private String name = null;

  @JsonProperty("price")
  private String price = null;

  @JsonProperty("shortDescription")
  private String shortDescription = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("category")
  private String category = null;

  @JsonProperty("expiredate")
  private String expiredate = null;

  @JsonProperty("sku")
  private String sku = null;

  @JsonProperty("slug")
  private String slug = null;

  @JsonProperty("thumbnail")
  private String thumbnail = null;

  @JsonProperty("ageGroups")
  private String ageGroups = null;

  @JsonProperty("images")
  private List<String> images = null;

  @JsonProperty("sizes")
  private List<String> sizes = null;

  @JsonProperty("colors")
  private List<String> colors = null;

  @JsonProperty("configurations")
  private List<String> configurations = null;

  @JsonProperty("related")
  private List<WebSubProduct> related = null;

  public WebProduct id(String id) {
    this.id = id;
    return this;
  }

   /**
   * holds value for id of the product. A unique way to track the product
   * @return id
  **/
  @Schema(description = "holds value for id of the product. A unique way to track the product")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public WebProduct name(String name) {
    this.name = name;
    return this;
  }

   /**
   * holds value for name
   * @return name
  **/
  @Schema(description = "holds value for name")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public WebProduct price(String price) {
    this.price = price;
    return this;
  }

   /**
   * holds value for price
   * @return price
  **/
  @Schema(description = "holds value for price")
  public String getPrice() {
    return price;
  }

  public void setPrice(String price) {
    this.price = price;
  }

  public WebProduct shortDescription(String shortDescription) {
    this.shortDescription = shortDescription;
    return this;
  }

   /**
   * holds value for shortDescription
   * @return shortDescription
  **/
  @Schema(description = "holds value for shortDescription")
  public String getShortDescription() {
    return shortDescription;
  }

  public void setShortDescription(String shortDescription) {
    this.shortDescription = shortDescription;
  }

  public WebProduct description(String description) {
    this.description = description;
    return this;
  }

   /**
   * holds value for description
   * @return description
  **/
  @Schema(description = "holds value for description")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public WebProduct category(String category) {
    this.category = category;
    return this;
  }

   /**
   * holds value for category
   * @return category
  **/
  @Schema(description = "holds value for category")
  public String getCategory() {
    return category;
  }

  public void setCategory(String category) {
    this.category = category;
  }

  public WebProduct expiredate(String expiredate) {
    this.expiredate = expiredate;
    return this;
  }

   /**
   * holds value for expiredate
   * @return expiredate
  **/
  @Schema(description = "holds value for expiredate")
  public String getExpiredate() {
    return expiredate;
  }

  public void setExpiredate(String expiredate) {
    this.expiredate = expiredate;
  }

  public WebProduct sku(String sku) {
    this.sku = sku;
    return this;
  }

   /**
   * holds value for sku
   * @return sku
  **/
  @Schema(description = "holds value for sku")
  public String getSku() {
    return sku;
  }

  public void setSku(String sku) {
    this.sku = sku;
  }

  public WebProduct slug(String slug) {
    this.slug = slug;
    return this;
  }

   /**
   * holds value for slug
   * @return slug
  **/
  @Schema(description = "holds value for slug")
  public String getSlug() {
    return slug;
  }

  public void setSlug(String slug) {
    this.slug = slug;
  }

  public WebProduct thumbnail(String thumbnail) {
    this.thumbnail = thumbnail;
    return this;
  }

   /**
   * holds value for thumbnail
   * @return thumbnail
  **/
  @Schema(description = "holds value for thumbnail")
  public String getThumbnail() {
    return thumbnail;
  }

  public void setThumbnail(String thumbnail) {
    this.thumbnail = thumbnail;
  }

  public WebProduct ageGroups(String ageGroups) {
    this.ageGroups = ageGroups;
    return this;
  }

   /**
   * holds value for ageGroups
   * @return ageGroups
  **/
  @Schema(description = "holds value for ageGroups")
  public String getAgeGroups() {
    return ageGroups;
  }

  public void setAgeGroups(String ageGroups) {
    this.ageGroups = ageGroups;
  }

  public WebProduct images(List<String> images) {
    this.images = images;
    return this;
  }

  public WebProduct addImagesItem(String imagesItem) {
    if (this.images == null) {
      this.images = new ArrayList<String>();
    }
    this.images.add(imagesItem);
    return this;
  }

   /**
   * Get images
   * @return images
  **/
  @Schema(description = "")
  public List<String> getImages() {
    return images;
  }

  public void setImages(List<String> images) {
    this.images = images;
  }

  public WebProduct sizes(List<String> sizes) {
    this.sizes = sizes;
    return this;
  }

  public WebProduct addSizesItem(String sizesItem) {
    if (this.sizes == null) {
      this.sizes = new ArrayList<String>();
    }
    this.sizes.add(sizesItem);
    return this;
  }

   /**
   * Get sizes
   * @return sizes
  **/
  @Schema(description = "")
  public List<String> getSizes() {
    return sizes;
  }

  public void setSizes(List<String> sizes) {
    this.sizes = sizes;
  }

  public WebProduct colors(List<String> colors) {
    this.colors = colors;
    return this;
  }

  public WebProduct addColorsItem(String colorsItem) {
    if (this.colors == null) {
      this.colors = new ArrayList<String>();
    }
    this.colors.add(colorsItem);
    return this;
  }

   /**
   * Get colors
   * @return colors
  **/
  @Schema(description = "")
  public List<String> getColors() {
    return colors;
  }

  public void setColors(List<String> colors) {
    this.colors = colors;
  }

  public WebProduct configurations(List<String> configurations) {
    this.configurations = configurations;
    return this;
  }

  public WebProduct addConfigurationsItem(String configurationsItem) {
    if (this.configurations == null) {
      this.configurations = new ArrayList<String>();
    }
    this.configurations.add(configurationsItem);
    return this;
  }

   /**
   * Get configurations
   * @return configurations
  **/
  @Schema(description = "")
  public List<String> getConfigurations() {
    return configurations;
  }

  public void setConfigurations(List<String> configurations) {
    this.configurations = configurations;
  }

  public WebProduct related(List<WebSubProduct> related) {
    this.related = related;
    return this;
  }

  public WebProduct addRelatedItem(WebSubProduct relatedItem) {
    if (this.related == null) {
      this.related = new ArrayList<WebSubProduct>();
    }
    this.related.add(relatedItem);
    return this;
  }

   /**
   * Get related
   * @return related
  **/
  @Schema(description = "")
  public List<WebSubProduct> getRelated() {
    return related;
  }

  public void setRelated(List<WebSubProduct> related) {
    this.related = related;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    WebProduct webProduct = (WebProduct) o;
    return Objects.equals(this.id, webProduct.id) &&
        Objects.equals(this.name, webProduct.name) &&
        Objects.equals(this.price, webProduct.price) &&
        Objects.equals(this.shortDescription, webProduct.shortDescription) &&
        Objects.equals(this.description, webProduct.description) &&
        Objects.equals(this.category, webProduct.category) &&
        Objects.equals(this.expiredate, webProduct.expiredate) &&
        Objects.equals(this.sku, webProduct.sku) &&
        Objects.equals(this.slug, webProduct.slug) &&
        Objects.equals(this.thumbnail, webProduct.thumbnail) &&
        Objects.equals(this.ageGroups, webProduct.ageGroups) &&
        Objects.equals(this.images, webProduct.images) &&
        Objects.equals(this.sizes, webProduct.sizes) &&
        Objects.equals(this.colors, webProduct.colors) &&
        Objects.equals(this.configurations, webProduct.configurations) &&
        Objects.equals(this.related, webProduct.related);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, name, price, shortDescription, description, category, expiredate, sku, slug, thumbnail, ageGroups, images, sizes, colors, configurations, related);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class WebProduct {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    price: ").append(toIndentedString(price)).append("\n");
    sb.append("    shortDescription: ").append(toIndentedString(shortDescription)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    category: ").append(toIndentedString(category)).append("\n");
    sb.append("    expiredate: ").append(toIndentedString(expiredate)).append("\n");
    sb.append("    sku: ").append(toIndentedString(sku)).append("\n");
    sb.append("    slug: ").append(toIndentedString(slug)).append("\n");
    sb.append("    thumbnail: ").append(toIndentedString(thumbnail)).append("\n");
    sb.append("    ageGroups: ").append(toIndentedString(ageGroups)).append("\n");
    sb.append("    images: ").append(toIndentedString(images)).append("\n");
    sb.append("    sizes: ").append(toIndentedString(sizes)).append("\n");
    sb.append("    colors: ").append(toIndentedString(colors)).append("\n");
    sb.append("    configurations: ").append(toIndentedString(configurations)).append("\n");
    sb.append("    related: ").append(toIndentedString(related)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
