/*
 * Store Harmony v3 Merchant API
 * Store Harmony software is an inventory and sales management solution for all SMEs. It provides important functions enable integration of a merchant store with payment systems and banking applications. This API can be used by payment providers to enable easy integrated checkout for their products. Orders are sent directly to Store  point of sale and inventory software for immediate processing # Authentication StoreHarmony Merchant Checkout offers two forms of authentication:   - Bearer Authentication (Register on www.storeharmony as a merchant and API key can be requested)   - OAuth2 (to be available)   - HASH Optionally generate a HMAC-SHA256 hash of the request body and include as a Header X-Hash-Data This may be required for certain types of requests   
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package com.storeharmony.api;

import com.storeharmony.api.invoke.ApiException;
import com.storeharmony.api.AdvancedQuery;
import com.storeharmony.api.WebStore;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for StoreHarmonyInventoryApi
 */
@Ignore
public class StoreHarmonyInventoryApiTest {

    private final StoreHarmonyInventoryApi api = new StoreHarmonyInventoryApi();

    /**
     * retrieve list of products from the merchant store
     *
     * Returns a list of available items from a merchant store which can be displayed for a client app to use to info their users on prices or availablity
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void listStoreInventoryTest() throws ApiException {
        String storeid = null;
        WebStore response = api.listStoreInventory(storeid);

        // TODO: test validations
    }
    /**
     * retrieve list of products from the merchant store
     *
     * Returns a list of available items from a merchant store which can be displayed for a client app to use to info their users on prices or availablity
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void listStoreInventoryPagedTest() throws ApiException {
        String storeid = null;
        String start = null;
        String size = null;
        WebStore response = api.listStoreInventoryPaged(storeid, start, size);

        // TODO: test validations
    }
    /**
     * retrieve list of products categories from the merchant store
     *
     * Returns a list of available items from a merchant store which can be displayed for a client app to use to info their users on prices or availablity
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void loadStoreCategoriesTest() throws ApiException {
        String storeid = null;
        WebStore response = api.loadStoreCategories(storeid);

        // TODO: test validations
    }
    /**
     * retrieve a product from the store getting its price, details and availability
     *
     * Returns the details about a store product which can be connected to a payment process or checkout process
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void loadStoreItemTest() throws ApiException {
        String storeid = null;
        String itemid = null;
        WebStore response = api.loadStoreItem(storeid, itemid);

        // TODO: test validations
    }
    /**
     * retrieve a product from the store getting its price, details and availability via a slug
     *
     * Returns the details about a store product usnig its slug
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void loadStoreItemBySlugTest() throws ApiException {
        String storeid = null;
        String slug = null;
        WebStore response = api.loadStoreItemBySlug(storeid, slug);

        // TODO: test validations
    }
    /**
     * retrieve a product from the store getting its price, details and availability
     *
     * Returns the details about a store product usnig its universal ID
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void loadStoreItemByUniqueIdTest() throws ApiException {
        String storeid = null;
        String itemid = null;
        WebStore response = api.loadStoreItemByUniqueId(storeid, itemid);

        // TODO: test validations
    }
    /**
     * searches and retrieves a list of products from the merchant store for category
     *
     * Returns a query of available items from a merchant store which can be displayed for a client app to use to info their users on prices or availablity under a category
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void loadStoreItemsForCategoryTest() throws ApiException {
        String storeid = null;
        String categoryid = null;
        WebStore response = api.loadStoreItemsForCategory(storeid, categoryid);

        // TODO: test validations
    }
    /**
     * searches and retrieves a list of products from the merchant store
     *
     * Returns a query of available items from a merchant store which can be displayed for a client app to use to info their users on prices or availablity
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void loadStoreItemsForCategoryByPagesTest() throws ApiException {
        String storeid = null;
        String categoryid = null;
        String start = null;
        String size = null;
        WebStore response = api.loadStoreItemsForCategoryByPages(storeid, categoryid, start, size);

        // TODO: test validations
    }
    /**
     * searches and retrieves a list of products from the merchant store
     *
     * Returns a query of available items from a merchant store which can be displayed for a client app to use to info their users on prices or availablity
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void searchStoreRecordsTest() throws ApiException {
        String storeid = null;
        String query = null;
        String start = null;
        String size = null;
        WebStore response = api.searchStoreRecords(storeid, query, start, size);

        // TODO: test validations
    }
    /**
     * retrieve list of products from the merchant store
     *
     * Returns a list of available items from a merchant store which can be displayed for a client app to use to info their users on prices or availablity
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void searchStoreRecordsMoreTest() throws ApiException {
        AdvancedQuery body = null;
        String storeid = null;
        WebStore response = api.searchStoreRecordsMore(body, storeid);

        // TODO: test validations
    }
}
