/*
 * Store Harmony v3 Merchant API
 * Store Harmony software is an inventory and sales management solution for all SMEs. It provides important functions enable integration of a merchant store with payment systems and banking applications. This API can be used by payment providers to enable easy integrated checkout for their products. Orders are sent directly to Store  point of sale and inventory software for immediate processing # Authentication StoreHarmony Merchant Checkout offers two forms of authentication:   - Bearer Authentication (Register on www.storeharmony as a merchant and API key can be requested)   - OAuth2 (to be available)   - HASH Optionally generate a HMAC-SHA256 hash of the request body and include as a Header X-Hash-Data This may be required for certain types of requests   
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package com.storeharmony.api;

import com.storeharmony.api.invoke.ApiException;
import com.storeharmony.api.TerminalPayment;
import com.storeharmony.api.WebOrder;
import com.storeharmony.api.WebOrderPayment;
import com.storeharmony.api.WebStore;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for StoreHarmonyOrderingApi
 */
@Ignore
public class StoreHarmonyOrderingApiTest {

    private final StoreHarmonyOrderingApi api = new StoreHarmonyOrderingApi();

    /**
     * retrieves the list of delivery services according to the zones supported by the store
     *
     * A store owner can map out the price of making deliveries to each part of their coverage. A zone could be titled &#x27;lagos mainland delivery&#x27; or &#x27;central area delivery&#x27;. Prices are listed per KG
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void loadDeliveryServicesTest() throws ApiException {
        String storeid = null;
        WebStore response = api.loadDeliveryServices(storeid);

        // TODO: test validations
    }
    /**
     * After an order has been placed and created with Storeharmony, the client can retrieve the order ID and use it to generate payment reference on their custom gateway implementation. They can use this call to pass the reference back to the storeharmony to use to verify the payment has been made. Popular gateways supported includes &#x27;pastack&#x27;, &#x27;flutterwave&#x27;, &#x27;global accelerex&#x27;, &#x27;sterling&#x27;
     *
     * Send payment for an already placed order. This call is made to notify storeharmony that an order has been paid for using a custom payment gateway implementation
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void payForOrderViaCustomGatewayTest() throws ApiException {
        WebOrderPayment body = null;
        String storeid = null;
        WebStore response = api.payForOrderViaCustomGateway(body, storeid);

        // TODO: test validations
    }
    /**
     * After an order is made, you place this call to request storeharmony to give you a payment link to redirect customer to for payment. Gateway settngs are made via customer settings
     *
     * To allow merchants use the embedded wallet function on their storeharmony or stocker, this call is important for payment processing. After an order is made, you place this call to request storeharmony to give you a payment link to redirect customer to for payment
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void payForOrderViaInternalGatewayTest() throws ApiException {
        String storeid = null;
        String orderid = null;
        WebStore response = api.payForOrderViaInternalGateway(storeid, orderid);

        // TODO: test validations
    }
    /**
     * For orders paid using a physical terminal or payment device, this call lets a PTSP notify storeharmony of a successful payment so that it can log it to the merchant dashboard or help fulfil a ecommerce order
     *
     * For orders paid using a physical terminal or payment device, the PTSP should create a callback that calls Storeharmony using this API to notify that a merchant on its network has been paid. A simple plugin can be developed to trigger this call
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void payViaMerchantPOSTerminalTest() throws ApiException {
        TerminalPayment body = null;
        String terminalId = null;
        WebStore response = api.payViaMerchantPOSTerminal(body, terminalId);

        // TODO: test validations
    }
    /**
     * places order of listed products to the merchant store. Note that a payment redirect link is also returned which allows the current buyer to make payment into this store if required. An implementation will redirect the customer to this link and later use /storeid/orderid to track the status of payment on this particular order
     *
     * Creates an order which is placed to the store dashboard for the merchant to immediately attend from their point of sales
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void placeOrderToStoreTest() throws ApiException {
        WebOrder body = null;
        String storeid = null;
        WebStore response = api.placeOrderToStore(body, storeid);

        // TODO: test validations
    }
    /**
     * retrieve an Order from the store to check the status
     *
     * Returns the details about the provided Order ID which also indicates if there is any successful payments and payment references on it
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void verifyOrderPlacedTest() throws ApiException {
        String storeid = null;
        String orderid = null;
        WebStore response = api.verifyOrderPlaced(storeid, orderid);

        // TODO: test validations
    }
}
